unit TCP_Client;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls, ComCtrls;

type
  TTCPClient = class(TForm)
    edRemoteIP: TEdit;
    btConnect: TButton;
    edRemotePort: TEdit;
    edSendData: TEdit;
    btSend: TButton;
    mbReceiveData: TMemo;
    btDisconnect: TButton;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ClientSocket1: TClientSocket;
    procedure btConnectClick(Sender: TObject);
    procedure btSendClick(Sender: TObject);
    procedure OnConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure btDisconnectClick(Sender: TObject);
    procedure OnDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  TCPClient: TTCPClient;

implementation

{$R *.DFM}

//Connect to Server by button click
procedure TTCPClient.btConnectClick(Sender: TObject);
begin
   ClientSocket1.Host := edRemoteIP.Text;
   ClientSocket1.Port := strtoint(edRemotePort.Text);
   ClientSocket1.Active := True;
end;

//event handling and display connection state
procedure TTCPClient.OnConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  btSend.Enabled := True;
  btDisconnect.Enabled := True;
  btConnect.Enabled := False;
  mbReceiveData.Clear;
  Statusbar1.SimpleText := 'Connected to ' + ClientSocket1.Host;
end;

procedure TTCPClient.OnDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  btSend.Enabled := False;
  btDisconnect.Enabled := False;
  btConnect.Enabled := True;
  Statusbar1.SimpleText := 'No Connection';
end;

//Error handling
procedure TTCPClient.OnError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  ShowMessage ('Connection Error');
  ClientSocket1.Active := False;
  btSend.Enabled := False;
  btDisconnect.Enabled := False;
  btConnect.Enabled := True;
  Statusbar1.SimpleText := 'No Connection';
end;

//send test string by button click
procedure TTCPClient.btSendClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText (edSendData.Text);
  edSendData.Text := '';
end;

//receive data handling
procedure TTCPClient.OnRead(Sender: TObject; Socket: TCustomWinSocket);
begin
  mbReceiveData.Text := mbReceiveData.Text + ClientSocket1.Socket.ReceiveText;
end;

//disconnect by button click
procedure TTCPClient.btDisconnectClick(Sender: TObject);
begin
  ClientSocket1.Active := False;
end;

end.
